﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Zeiterfassung
{
    class Zeiterfassung42
    {
        // TODO: später!!!
    }

    class Person
    {
        string vorname;
        string nachname;
        string anrede;
        DateTime geburtsdatum;
        public Person(string vorname, string nachname, string anrede, DateTime geburtsdatum)
        {
            this.vorname = vorname;
            this.nachname = nachname;
            this.anrede = anrede;
            this.geburtsdatum = geburtsdatum;
        }

        public virtual bool DarfBüroAlleineBetreten()
        {
            return false;
        }

        public virtual int GibPersonalnummer()
        {
            return -1;
        }

        public virtual void Kommt()
        { }

        public virtual void Geht()
        { }

        public string Nachname
        { get { return nachname; } }
    }

    class Mitarbeiter : Person
    {
        static int nächsteZuVergebendePersonalnummer = 0;
        int personalnummer;
        public Mitarbeiter(string vorname, string nachname, string anrede, DateTime geburtsdatum)
        : base(vorname, nachname, anrede, geburtsdatum)
        {
            personalnummer = nächsteZuVergebendePersonalnummer;
            nächsteZuVergebendePersonalnummer++;
        }
        public override bool DarfBüroAlleineBetreten()
        {
            return true;
        }
        public override int GibPersonalnummer()
        {
            return personalnummer;
        }
        public override string ToString()
        {
            return Nachname;
        }
    }

    class Gast : Person
    {
        Mitarbeiter gastgeber;
        public Gast(string vorname, string nachname, string anrede, DateTime geburtsdatum, Mitarbeiter gastgeber)
        : base(vorname, nachname, anrede, geburtsdatum)
        {
            if(gastgeber == null)
            {
                throw new ApplicationException("Gastgeber ist null.");
            }
            this.gastgeber = gastgeber;
        }

        KommtGehtZeit kommtGehtZeit;

        public override void Kommt()
        {
            if(kommtGehtZeit != null)
            {
                throw new ApplicationException("Instanz von Gast zweimal benutzt!");
            }
            kommtGehtZeit = new KommtGehtZeit();
        }

        public override void Geht()
        {
            if(kommtGehtZeit == null)
            {
                throw new ApplicationException("Kommen/Gehen-Fehler!");
            }
            kommtGehtZeit.Geht();
        }
    }

    class KommtGehtZeit
    {
        DateTime kommt;
        DateTime geht;
        bool istAnwesend = true;
        public KommtGehtZeit()
        {
            kommt = DateTime.Now;
        }

        public void Geht()
        {
            if(!istAnwesend)
            {
                throw new ApplicationException("Kommt/Geht-Fehler!");
            }
            geht = DateTime.Now;
            istAnwesend = false;
        }

        public TimeSpan Dauer
        {
            get
            {
                if(istAnwesend)
                {
                    return DateTime.Now - kommt;
                }
                else
                {
                    return geht - kommt;
                }
            }
        }
    }

}
